$Id: Worker.lhs,v 3.2 2003/09/08 16:25:31 afc Exp $
$Log: Worker.lhs,v $
Revision 3.2  2003/09/08 16:25:31  afc
removed a strictness annotation

Revision 3.1  2002/05/17 16:03:25  ajc99
removed classes, and removed key from countAssocs.

Revision 3.0  2002/04/04 10:46:41  ajc99
Now uses hierarchical background knowledge.

Revision 2.1  2002/02/06 15:23:01  ajc99
Added DeepSeq

Revision 2.0  2001/12/04 18:40:32  ajc99
Worker reads in the QueryTree and does the counting, dumping its output.


> module Main
> where

> import System(getArgs)
> import Dumper
> import ADT
> import Cover
> import FileIO
> import DeepSeq

read tree. count. write counts

> main :: IO()
> main =
>   do
>     args <- getArgs
>     if length args /= 4 
>	then putStrLn "usage: filebase level datachunk workingdir"
>	else let [filebase,level,datachunk,workingdir] = args in 
>         do
>           kb <- readKnowledgeBase (filebase ++ datachunk)
>           (modenums,bg,key,oqueries) <- 
>                        undumpData filebase workingdir level
>	    queries <- eval oqueries
>           let kbcomp  = map (compileKB modenums key) kb
>               counted = ((countAssocs $!! kbcomp) bg modenums) $!! queries
> 	    (dumpQueries (filebase ++ "." ++ datachunk) workingdir) counted

profiling shows that if we remove the $!! from this line then memory usage is down to 2/3.
  > 	    (dumpQueries (filebase ++ "." ++ datachunk) workingdir) $!! counted


> eval x = return $!! x